/**
* Unreal World
* Definicje klas zarządzających dźwiękiem
* Copyright © 2016 Żywek
**/
#ifdef _WIN32
#pragma warning(disable: 4244 4305)
#endif
#ifndef file1_h
#define file1_h
#include <fmod.hpp>
#include <string>
#include <logger.h>
#include <SFML/Audio.hpp>
using namespace std;
class Audio
{
public:
	enum sound_type { BACK, CLICK, ECHO, ENTER1, LEFT, NAV1, NAV2, OPN, OPN2, PAUSE, STEP1, STEP2, STEP3, STEP4, STEP5, STEP6, EXPLO1L, EXPLO1R, JET1, GONG1, BONUS1, BONUS2, DEAD, NOTIFICATION, COUNT };
	enum m_type { LOADING, BACKGROUND, DAY1, AMBIENT01, NIGHT1, M_COUNT };
enum SNDLoad {SND_ALL, SND_GAME, SND_MENU, SND_PED, SND_PLAYER, SND_WORLD};
	Audio(bool load_everything = false);
	~Audio();
	bool loadMusic();
	bool loadSounds(SNDLoad sndt);
bool loadSound(sound_type t);
bool unloadSounds();
bool unloadSound(sound_type t);
	void playSound(sound_type sound);
	void play3DSound(sound_type sound, float x, float y, float z);
	void setSoundPitch(sound_type type, float p);
	void setSoundVolume(sound_type type, float v);
	void setSoundPosition(sound_type type, float p1, float p2, float p3);
	void setMusicVolume(m_type mtype, float v);
	float getMusicVolume(m_type mtype);
	void setSoundLoop(sound_type type, bool l);
	void setMusicLoop(m_type mtype, bool l);
	void setMinMaxDistance(sound_type type, float dist, float dist2);
	void stopSound(sound_type type);
	void destroySound(sound_type sound);
	void playMusic(m_type mtype);
void playMusicAt(m_type mtype, float x, float y, float z);
	void stopMusic(m_type mtype);
	void loading();
		void update(float x, float y, float z);
private:
int iIndex = 0;
int iCount;
bool rel;
bool loaded = false;
	FMOD_VECTOR lpos;
	bool listener = true;
		const float dfactor = 1.0f;
		FMOD::System *sysfmod;
	FMOD::Sound *sound[COUNT];
	FMOD::Channel *chan[COUNT];
	sf::Music music[M_COUNT];
string name[COUNT] = { "ui/back.ogg", "ui/click.ogg", "ui/echo.ogg", "ui/enter1.ogg", "ui/lev.ogg", "ui/nav_lr.ogg", "ui/nav_ud.ogg", "ui/open.ogg", "ui/openset.ogg", "ui/pause.ogg", "steps/1.ogg", "steps/2.ogg", "steps/3.ogg", "steps/4.ogg", "steps/5.ogg", "steps/6.ogg", "ambient/explo11.ogg", "ambient/explo12.ogg", "ambient/jet1.ogg", "ambient/tower.ogg", "ped/bonus1.ogg", "ped/bonus2.ogg", "ped/dead.ogg", "frontend/notification.ogg"};

string name2[M_COUNT] = {"m/0X000D3DFCC.ogg", "m/background.ogg", "ambient/1.ogg", "ambient/2.ogg", "ambient/3.ogg"};

};
#endif
